<script lang="ts">
import Vue from 'vue';

interface ColorProps {
  primary: string;
  hover: string;
}

export default Vue.extend({
  name: 'Badge',
  props: {
    badge: {
      type: Object,
      required: true,
      default: null,
    },
    isDark: {
      type: Boolean,
      required: false,
      default: false,
    },
    color: {
      type: Object as () => ColorProps,
      required: false,
      default: () => ({
        primary: '#eee7fd',
        hover: '#f6f3fe',
      }),
    },
  },
  computed: {
    badgeStyles(): object {
      return {
        '--badge-bg-color': this.color.primary,
        '--badge-hover-color': this.color.hover,
      };
    },
  },
});
</script>

<template>
  <a
    v-if="badge.link || badge.url"
    :href="badge.link || badge.url"
    :data-ga-name="badge.data_ga_name"
    :data-ga-location="badge.data_ga_location"
    class="badge"
    :class="{ 'badge--dark': isDark }"
    :style="badgeStyles"
  >
    {{ badge.text }}
    <SlpIcon
      v-if="badge.icon"
      :icon="badge.icon"
      :variant="badge.variant"
      size="sm"
      class="slp-ml-8"
    />
  </a>
  <div v-else class="badge badge--text" :style="badgeStyles">
    <SlpIcon
      v-if="badge.icon"
      :icon="badge.icon"
      :variant="badge.variant"
      class="slp-mr-8"
      size="20"
    />
    {{ badge.text }}
  </div>
</template>

<style lang="scss" scoped>
.badge {
  padding: $spacing-8 $spacing-16;
  border-radius: 20px;
  margin-bottom: $spacing-16;
  line-height: 1;
  display: inline-flex;
  align-items: center;
  font-weight: $font-weight-bold;
  color: $color-text-300;
  background-color: var(--badge-bg-color);
  transition: background-color 0.3s ease;

  &:hover {
    background-color: var(--badge-hover-color);
  }

  &--dark {
    display: inline-flex;
    align-items: center;
    background-color: $color-primary-200;
    transition: all 0.3s ease;
    color: $color-surface-50;
    &:hover {
      background-color: $color-surface-200;
      color: $color-primary-200;
    }
    :deep .slp-icon {
      margin-top: -3px;
    }
  }

  &--text {
    font-weight: bold;

    &:hover {
      background: var(--badge-bg-color);
    }
  }
}
</style>
